<?php
// $Name$

function views_bonus_panels_threecol_stk_info() {
  $items['panels_threecol_stk'] = array(
    'name' => t('Panels: Teasers, 1 top + 3 columns'),
    'description' => t('Show views as teasers with the first entry spanning 3 columns on the top, then additional entries alternating left, middle and right beneath.'),
    'requires' => array('panels'),
  );
  return $items;
}

function views_bonus_panels_threecol_stk_style_plugins() {
  $items['panels_threecol_stk'] = array(
    'name' => t('Panels: Teasers, 1 top + 3 columns'),
    'theme' => 'views_bonus_panels_threecol_stacked',
    'summary_theme' => 'views_summary',
  );
  return $items;
}

/**
 * Because views doesn't currently support configuration options for
 * plugins, the best way to make configuration changes here is 
 * to override the theme.
 */
function theme_views_bonus_panels_threecol_stacked($view, $nodes, $type) {
  $teasers = true;
  $links = true;
  if (!module_exist('panels')) {
    return theme('views_view_nodes', $view, $nodes, $type, $teasers, $links);
  }
  $content = array();
  foreach ($nodes as $count => $n) {
    $node = node_load($n->nid);
    if ($count == 0) {
      $section = 'top';
    }
    else switch (($count - 1) % 3) {
      case 0:
        $section = 'left';
        break;
      case 1:
        $section = 'middle';
        break;
      case 2:
        $section = 'right';
        break;
    }
    $content[$section] .= node_view($node, $teasers, false, $links);
  }
  return panels_print_layout('threecol_33_34_33_stacked', $content);
}
